; SID+Midi player playback wrapper
; DASM source
; 4mat/Ate Bit - 1/4/2019

; While playing:
; SPACE = Fast forward track
; RUN/STOP = Stop / Restart track

	CRUNCHER = 0 ; Set this to 1 if you're going to crunch the compiled file. (load/run address = $0801)
	
	org	$0801
	
	.IF CRUNCHER = 0
	.byte	$0b,$08,$ef,$00,$9e,$32,$30,$36,$32,0,0,0,0
	org	$080e
	.ENDIF
start

	sei

	lda #$35
	sta $01
	
	jsr intro

	ldx #$27
showinstruct
	lda instructiontext,x
	sta $0770,x
	dex
	bpl showinstruct
	
	jsr startsong
		
songrasterval
	lda #$7f
	sta $dc00
	lda $dc01
	and #$10
	beq skipraster
	lda keypressed
	cmp #$01
	bne songkeynormal
	lda $dc01
	and #$80
	beq songrasterval
	lda #$00
	sta keypressed
songkeynormal
	lda $dc01
	and #$80
	beq stopsong
	lda #$fe
	cmp $d012
	bne songrasterval


skipraster
	lda songstatus
	cmp #$01
	beq songrasterval
	
	lda #$0a
	sta $d020

	jsr $c003 ; play midi
		
	lda #$00
	sta $d020
	
	jmp songrasterval

startsong
	lda #$01 ; Number of music players used.
bufferval
	ldx #$02 ; Sid buffer offset 
cartval
	ldy #$00 ; Cart type 
	jsr $c000 ; init driver
	rts

	; Stop/Restart midi
	
stopsong
	lda #$01
	sta keypressed
	lda songstatus
	cmp #$01
	beq restartsong
	jsr $c006 ; stop midi
	lda #$01
	sta songstatus
	jmp songrasterval
restartsong
	jsr startsong
	lda #$00
	sta songstatus
	jmp songrasterval

songstatus
	.byte $00
keypressed
	.byte $00

translate
	cmp #$40
	bcc translateout
	cmp #$5c
	bcc translatecaps
	clc
	sbc #$5f
translateout
	rts
translatecaps
	rts
	
intro
	lda #$16
	sta $d018
	lda #$00
	sta $d020
	lda #$0c
	sta $d021
	lda #155
	sta 53265
	lda #$00
	sta $d01c
	sta $d015
	sta $dc00
	sta $dc01
	lda #$ff
	sta $dc02
	lda #$00
	sta $dc03
	lda #$08
	sta $d016
	
	ldx #$00
copypic
	lda $0c00,x
	sta $0400,x
	lda $0d00,x
	sta $0500,x
	lda $0e00,x
	sta $0600,x
	lda $0f00,x
	sta $0700,x
	lda #$00
	sta $d800,x
	sta $d900,x
	sta $da00,x
	lda #$0c
	sta $db00,x
	inx
	bne copypic

	ldx #$00
showsongname
	lda song_name,x
	cmp #$00
	beq stopsongname
	jsr translate
	sta $0484,x
	inx
	bne showsongname
	
stopsongname
	ldx #$00
showsongauthor
	lda song_author,x
	cmp #$00
	beq stopsongauthor
	jsr translate
	sta $04ac,x
	inx
	bne showsongauthor	

stopsongauthor
	ldx #$00
showsongrelease
	lda song_released,x
	cmp #$00
	beq stopsongrelease
	jsr translate
	sta $04d4,x
	inx
	bne showsongrelease

stopsongrelease

	; cart type
	lda #$01
	sta io_selectamount+$01	
	jsr io_waitdevice
	lda $fe
	sta cartval+$01
	tax
	ldy io_cartchoice,x
	lda #$01
	sta $dad7,y

	; sid delay
	ldx #$4f
	lda #$00
copypic2
	sta $db00,x
	dex
	bne copypic2
	
	lda #$07
	sta io_selectamount+$01	
	jsr io_waitdevice

	lda $fe
	sta bufferval+$01
	clc
	adc #$30
	sta $073b
	lda #$01
	sta $db3b
	
	; press space
	ldx #$50
	lda #$00
copypic3
	sta $db50,x
	dex
	bne copypic3
	
	lda #$0a
	sta io_selectamount+$01	
	jsr io_waitdevice

	
	rts

io_waitdevice	
	lda $d012
	cmp #$80
	bne io_waitdevice	
	lda $dc01
	cmp #$ff
	bne io_waitdevice

	
	lda #$00
	sta $dc00
	sta $dc01
	lda #$ff
	sta $fe
io_waitdevice1	
	lda $d012
	cmp #$fe
	bne io_waitdevice1
io_selectamount
	ldx #$01
io_selectdevice
	lda io_keydc00,x
	sta $dc00
	lda $dc01
	and io_keydc01,x
	bne io_nodevice
	stx $fe
	rts
io_nodevice
	dex
	bpl io_selectdevice
	lda $fe
	cmp #$ff
	beq io_waitdevice1
	rts


io_keydc00
	.byte $ef,$7f,$7f,$fd,$fd,$fb,$fb,$f7,$f7,$ef,$7f
io_keydc01
	.byte $08,$01,$08,$01,$08,$01,$08,$01,$08,$01,$10
	
io_cartchoice
	.byte $00,$10

instructiontext
	.byte $53,$50,$41,$43,$45,$20,$14,$0f
	.byte $20,$46,$46,$57,$44,$20,$2c,$20
	.byte $52,$15,$0e,$2f,$53,$14,$0f,$10
	.byte $20,$14,$0f,$20,$53,$14,$0f,$10
	.byte $2f,$52,$05,$13,$14,$01,$12,$14

	.byte "Press SPACE to FFWD , run/stop to stop/restart song"
	
song_name
	.byte "Blank config, one pattern"
	.byte $00
song_author
	.byte "????"
	.byte $00
song_released
	.byte "????"
	.byte $00

	org $0c00-$02
	.incbin readme.prg
	
	; Memory $1000-$bfff is free for your songs (and $e000-$ffff if file is crunched)
	
	org $1000-$02 ; -$02 to remove .prg header, -$7c to remove .sid header
	
	.incbin piano-1000.prg

	.include mididriver_static.asm 
	
